//
// CTelnetSettingsDialog.h
//
//	MiniTelnet application
//	Telnet settings dialog director
//	PowerPlant version
//
//	Copyright  1993-95, FrostByte Design / Eric Scouten
//

#pragma once

#include <LBroadcaster.h>
#include <LDialogBox.h>

#include "MiniTelnet.const.h"


//***********************************************************

class CTelnetSettingsDialog : public LDialogBox, public LBroadcaster {

// This class provides the dialog box used to collect information on the Telnet connection.
// It packages these settings into a record used by CTelnetTerminal to open connections.

public:
	enum { class_ID = 'Tstg' };

	static CTelnetSettingsDialog* CreateDialogBoxStream(LStream* inStream);
					CTelnetSettingsDialog(LStream* inStream);

	// settings record functions

	virtual void		DefaultSettings();
	virtual void		GrabSettings(TelnetSettingsRec& outSettings);
	virtual void		PutSettings(TelnetSettingsRec& inSettings);

	// menu/command handling

	virtual void		ListenToMessage(MessageT inMessage, void *ioParam);
	virtual Boolean		ObeyCommand(CommandT	inCommand, void* ioParam);
	virtual void		FindCommandStatus(CommandT inCommand, Boolean& outEnabled, Boolean& outUsesMark,
						Char16& outMark, Str255 outName);

	// file interactions
	
	void				DoSaveFile();

};