//
// TurboTCP.types.h
//
//	TurboTCP library
//	Internal type definitions
//
//	Copyright  1993-95, FrostByte Design / Eric Scouten
//

#pragma once

#include "TurboTCP.buildflags.h"

#if TurboTCP_UH2
	#include <MacTCP.h>
#else
	#include <TCPPB.h>
#endif

#if TurboTCP_PPC
	#pragma options align=mac68k
#endif

//***********************************************************
//
// Type IDs for async queue entries
//

enum {
	asyncCall = 1,
	resolverCall,
	notifyStream,
	disposeStream
};


//***********************************************************

typedef struct TurboTCPQElem TurboTCPQElem;

struct TurboTCPQElem {

// Special OS queue entry with a pointer to an arbitrary object.

	TurboTCPQElem() {}
	TurboTCPQElem(void* itsSelfLink)
		{ qSelfLink = itsSelfLink; }
	
	QElemPtr	qLink;
	short	qType;
	void*	qSelfLink;				// link to whatever object we had

};



//***********************************************************

struct TurboTCPiopb {

// Variation on the standard MacTCP I/O parameter block that contains
// info for the async completion routine.

	struct TCPiopb	itsParamBlock;			// the TCP parameter block
	QHdr*			itsQueue;				// the queue were in
	TurboTCPQElem		itsQElem;				// the queue entry
};

typedef struct TurboTCPiopb TurboTCPiopb;


//***********************************************************

#if TurboTCP_PPC
	#pragma options align=reset
#endif
