// File "main.h" -
// This header file is Copyright Matt Slot & Slot-Machines Ltd.,  1994

#include "event filter.h"

// * ****************************************************************************** *

// Info about My Application
#define	kCreatorType		'CWnd'
#define kApplFileType		'appe'
#define kPrefsFileType		'PREF'
#define kPrefsFileName		"\pappe Window Prefs"

// * ****************************************************************************** *
// * ****************************************************************************** *

// By setting the second value to the creator of a given application, the
// window will only be visible in that applications context. The default
// is to leave it visible always.

#define	kAllApplications	'****'
#define kMyApplication		'****'

// * ****************************************************************************** *
// * ****************************************************************************** *

// The current version of the Text Services Manager does not return
// a color window in a color environment. These flags determine whether
// we will patch NewWindow to NewCWindow, or whether we will try to
// get by cleanly without trap-patching.

#define	kPatchOutNewWindow	 1

// * ****************************************************************************** *
// * ****************************************************************************** *

#define kAppleMenuID			 128
#define kAppleMenuAboutItem		   1
#define kAppleMenuSeparator1	   2

#define kFileMenuID				 129
#define kFileMenuShowHideItem	   1
#define kFileMenuCloseItem		   2
#define kFileMenuSeparator1		   3
#define kFileMenuQuitItem		   4

#define kEditMenuID				 130
#define kEditMenuUndoItem		   1
#define kEditMenuSeparator1		   2
#define kEditMenuCutItem		   3
#define kEditMenuCopyItem		   4
#define kEditMenuPasteItem		   5
#define kEditMenuClearItem		   6

// * ****************************************************************************** *
// * ****************************************************************************** *

typedef struct {
	short flags : 11;
	short bkgdOnly : 1;
	short hasColorQD : 1;
	short hasGDevices : 1;
	short hidden : 1;
	short quitting : 1;
	
	short frontMBarHeight;
	long hotApplication;
	long saveNewWindow;
	Ptr myFilter;

	EventRecord theEvent;
	WindowPtr window;
	
	short appFile;
	FSSpec cloneSpec;
	ContextPtr myContext, frontContext;
	} GlobalsRec;

// * ****************************************************************************** *
// * ****************************************************************************** *
// Function Prototypes

void DoInit(void);
void DoLoop(void);
void DoMenuItem(long theMenuAndItem);
short DoDispose(void);
void main(void);