#ifndef _WDEF_GLOBALS
#define _WDEF_GLOBALS

#include <Movies.h>

/* allocated by WDEF Globals.c and kept by Gestalt() */
typedef struct
{	PicHandle	pic, frame;
	struct
	{	Boolean		clonePic:1;		/* T => clone pic and dispose on close
									   F => copy handle, dispose as per sharePic */
		Boolean		sharePic:1;		/* T => don't dispose on close
									   F => DetachResource() on open,
									        dispose on close */
		Boolean		cloneFrame:1;
		Boolean		shareFrame:1;
		Boolean		spare:4;
	}			flags;
	char		spare1;
	int			spare2;
	/* following fields used by Pictoid XCMD */
	WindowPtr	wlist;
	WindowPtr	editPalette;
	int			editMode;
	int			paletteCount;
	struct
	{	Boolean		doneSetup:1;
		Boolean		spare3:6;
		Boolean		defaultMsg:1;
		Boolean		enteredMovies:1;
		Boolean		system7:1;
		Boolean		quickTime:1;
		Boolean		usingColor:1;
		Boolean		grayishTextOr:1;
		Boolean		directPixMaps:1;
		Boolean		deepGWorlds:1;
		Boolean		hasColor:1;
	} pFlags;
}	WDEFGlobals, *WDEFGlobalsPtr, **WDEFGlobalsHand;

OSErr GetWDEFGlobals(Boolean, WDEFGlobals **);

/* allocated by WDEF, first three fields private to WDEF, rest set to zero */
typedef struct
{	PicHandle	pic, frame;
	struct
	{	Boolean		disposePic:1;
		Boolean		disposeFrame:1;
		Boolean		unused:6;
		char		unused2;
		int			unused3;
	}			flags;
	PicHandle	content;
	WindowPtr	next;
	Handle		picName, frameName;
	Boolean		autoHilite:1;
	Boolean		hilite:1;
	Boolean		colorHilite:1;
	Boolean		blendHilite:1;
	Boolean		wasVis:1;
	Boolean		isMovie:1;
	Boolean		running:1;
	Boolean		loopMovie:1;
	Boolean		autoReverse:1;
	Boolean		spare2:7;
	int			spare3;
	Movie		theMovie;
	union
	{	struct	{ Handle mouseWithin, mouseDown, mouseStillDown, mouseUp, idle; }
				sym;
		Handle	lit[5];
	}			script;
	long		idleTime;
	long		idleCount;
}	WDEFPrivate, *WDEFPrivatePtr, **WDEFPrivateHand;

#define mWITH	0
#define mDOWN	1
#define mSTILL	2
#define mUP		3
#define IDLE	4

#endif